<?xml version="1.0" encoding="ISO-8859-1"?>
<!DOCTYPE xsl:stylesheet [
<!ENTITY nbsp "&#160;">
<!ENTITY egrave "&#232;">
<!ENTITY euro "&#8364;">
<!ENTITY agrave "&#224;">
<!ENTITY eacute "&#233;">
]>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns="http://www.xemelios.org/namespaces#cg-1.0" xmlns:n="http://www.xemelios.org/namespaces#cg-1.0" xmlns:added="http://projets.admisource.gouv.fr/xemelios/namespaces#added" version="2.0">
    <!-- Paramtres de sortie -->
    <xsl:character-map name="accents">
        <xsl:output-character character="" string="&amp;#224;"/>
        <xsl:output-character character="" string="&amp;#233;"/>
        <xsl:output-character character="" string="&amp;#232;"/>
        <xsl:output-character character="" string="&amp;#234;"/>
        <xsl:output-character character="" string="&amp;#235;"/>
        <xsl:output-character character="" string="&amp;#238;"/>
        <xsl:output-character character="" string="&amp;#239;"/>
        <xsl:output-character character="" string="&amp;#244;"/>
        <xsl:output-character character="" string="&amp;#249;"/>
    </xsl:character-map>
    <xsl:output method="xhtml" indent="yes" use-character-maps="accents" encoding="ISO-8859-1"/>
    <xsl:decimal-format name="decformat" decimal-separator="," grouping-separator=" " digit="#" pattern-separator=";" NaN="NaN" minus-sign="-"/>

    <!-- Inclusion des XSL externes -->
    <xsl:include href="./common-xsl/Style.xsl"/>
    <xsl:include href="./common-xsl/Error.xsl"/>
    <xsl:include href="./common-xsl/Navigate.xsl"/>
    <xsl:include href="./common-xsl/Header.xsl"/>
    <xsl:include href="./common-xsl/Number.xsl"/>

    <!-- Paramtres d'entre -->
    <xsl:param name="show.formulaire"/>
    <xsl:param name="browser-destination"/>

    <!-- Paramtres d'entre de la liste de rsultat -->
    <xsl:param name="generated.id">0</xsl:param>

    <!-- Paramtres d'erreur -->
    <xsl:param name="error.message">nomessage</xsl:param>

    <!-- Variables -->
    <xsl:variable name="page-format" select="paysage"/>
    <xsl:variable name="NumPage" select="/n:CompteGestion/n:AffectationResultats/n:PageAffectationResultats/n:Pied/@NumPage"/>
    <xsl:variable name="Entete">
        <xsl:copy-of select="/n:CompteGestion/n:Entete"/>
    </xsl:variable>

    <!-- pour eviter les sorties parasites de tags non matches -->
    <xsl:template match="*"/>

    <xsl:template match="/n:CompteGestion">
        <html>
            <head>
                <title>Affectation des r&#233;sultats</title>
                <xsl:call-template name="style"/>
            </head>
            <body width="100%">
                <xsl:if test="$error.message!='nomessage'">
                    <xsl:attribute name="onload">javascript:showDialog('<xsl:value-of select="$error.message"/>');</xsl:attribute>
                </xsl:if>
                <xsl:call-template name="Error"><!--xsl:with-param name="error.message" select="$error.message"/--></xsl:call-template>
                <xsl:call-template name="navigate">
                    <xsl:with-param name="docId">compteGestion</xsl:with-param>
                    <xsl:with-param name="etatId">AffectationResultats</xsl:with-param>
                    <xsl:with-param name="elementId">PageAffectationResultats</xsl:with-param>
                    <xsl:with-param name="sous.elementId">LigneAffectationResultats</xsl:with-param>
                    <xsl:with-param name="NumPage" select="$NumPage"/>
                    <xsl:with-param name="Entete" select="$Entete"/>
                    <xsl:with-param name="show.formulaire" select="$show.formulaire"/>
                    <xsl:with-param name="show.formulaire.compte" select="0"/>
                    <xsl:with-param name="show.depense.recette" select="0"/>
                </xsl:call-template>
                <br/>
                <br/>
                <br/>
               <xsl:choose>
                    <xsl:when test="n:AffectationResultats/n:PageAffectationResultats/@Modele='11'">
                        <xsl:call-template name="header">
                            <xsl:with-param name="Entete" select="$Entete"/>
                            <xsl:with-param name="Titre">D&#233;termination du r&#233;sultat d&apos;exploitation de l&apos;exercice <xsl:value-of select="n:AffectationResultats/n:PageAffectationResultats/n:EnteteAffectationResultats/@ExerciceN_1"/> &#224; affecter au cours de l&apos;exercice <xsl:value-of select="n:AffectationResultats/n:PageAffectationResultats/n:EnteteAffectationResultats/@ExerciceN"/></xsl:with-param>
                        </xsl:call-template>
                        <br/>
                        <br/>
                        <br/>
                        <br/>
                        <xsl:call-template name="mainTable.c1">
                            <xsl:with-param name="el" select="/n:CompteGestion/n:AffectationResultats/n:PageAffectationResultats"/>
                        </xsl:call-template>
                    </xsl:when>
                    <xsl:when test="n:AffectationResultats/n:PageAffectationResultats/@Modele='12' or n:AffectationResultats/n:PageAffectationResultats/@Modele='13'">
                        <xsl:call-template name="header">
                            <xsl:with-param name="Entete" select="$Entete"/>
                            <xsl:with-param name="Titre">Tableau g&#233;n&#233;ral d&apos;affectation des r&#233;sultats de l&apos;exercice <xsl:value-of select="n:AffectationResultats/n:PageAffectationResultats/n:EnteteAffectationResultats/@ExerciceN_1"/> au cours de l&apos;exercice <xsl:value-of select="n:AffectationResultats/n:PageAffectationResultats/n:EnteteAffectationResultats/@ExerciceN"/></xsl:with-param>
                        </xsl:call-template>
                        <br/>
                        <br/>
                        <br/>
                        <br/>
                        <xsl:call-template name="mainTable.c2">
                            <xsl:with-param name="el" select="/n:CompteGestion/n:AffectationResultats/n:PageAffectationResultats"/>
                        </xsl:call-template>
                    </xsl:when>
                    <xsl:when test="n:AffectationResultats/n:PageAffectationResultats/@Modele='25' or n:AffectationResultats/n:PageAffectationResultats/@Modele='26'">
                        <xsl:call-template name="header">
                            <xsl:with-param name="Entete" select="$Entete"/>
                            <xsl:with-param name="Titre">Situation des comptes 110, 111, 114 et 119 &#224; la cl&#244;ture de l&apos;exercice <xsl:value-of select="n:AffectationResultats/n:PageAffectationResultats/n:EnteteAffectationResultats/@ExerciceN"/></xsl:with-param>
                        </xsl:call-template>
                        <br/>
                        <br/>
                        <br/>
                        <br/>
                        <xsl:call-template name="mainTable.c3">
                            <xsl:with-param name="el" select="/n:CompteGestion/n:AffectationResultats/n:PageAffectationResultats"/>
                        </xsl:call-template>
                    </xsl:when>
                </xsl:choose>
                <br/>
                <br/>
                <br/>
                <br/>
                <p>
                    <center>Page - <xsl:value-of select="$NumPage"/></center>
                </p>
            </body>
        </html>
    </xsl:template>

    <xsl:template name="mainTable.c1">
        <xsl:param name="el"/>
        <table width="100%" id="main" class="bordered">
            <colgroup>
                <col width="20%"/>
                <col width="20%"/>
                <col width="20%"/>
                <col width="20%"/>
                <col width="20%"/>

            </colgroup>
            <thead>
                <tr class="titre">
                    <td class="titre bold center bordered">N ET INTITULE DES SUBDIVISIONS</td>
                    <td class="titre bold center bordered">RESULTAT D&apos;EXPLOITATION DE L&apos;EXERCICE <xsl:value-of select="$el/n:EnteteAffectationResultats/@ExerciceN_1"/></td>
                    <td class="titre bold center bordered">RESULTAT D&apos;EXPLOITATION DE L&apos;EXERCICE <xsl:value-of select="$el/n:EnteteAffectationResultats/@ExerciceN_1"/> RETENU PAR L'AUTORITE DE TARIFICATION</td>
                    <td class="titre bold center bordered">RESULTAT INCORPORE AU BUDGET DE L&apos;EXERCICE <xsl:value-of select="$el/n:EnteteAffectationResultats/@ExerciceN_1"/></td>
                    <td class="titre bold center bordered">RESULTAT A AFFECTER AU TITRE DE L&apos;EXERCICE <xsl:value-of select="$el/n:EnteteAffectationResultats/@ExerciceN_1"/></td>
                </tr>
            </thead>
            <tbody>
                <xsl:for-each select="$el/n:LigneAffectationResultats">
                    <tr>
                        <xsl:choose>
                            <xsl:when test="$generated.id!='0' and @added:generated-id=$generated.id">
                                <xsl:attribute name="id">highlighted</xsl:attribute>
                            </xsl:when>
                            <xsl:otherwise>
                                <xsl:choose>
                                    <xsl:when test="(position() mod 2) = 0">
                                        <xsl:attribute name="id">colorised1</xsl:attribute>
                                    </xsl:when>
                                    <xsl:otherwise>
                                        <xsl:attribute name="id">colorised2</xsl:attribute>
                                    </xsl:otherwise>
                                </xsl:choose>
                            </xsl:otherwise>
                        </xsl:choose>
                        <xsl:choose>
                            <xsl:when test="contains(lower-case(@LibelleBC),'total')">
                                <td class="right bordered bold"><xsl:value-of select="@LibelleBC"/></td>
                                <td class="center bordered bold"><xsl:value-of select="@Gris"/></td>
                                <td class="center bordered bold"><xsl:value-of select="@Gris"/></td>
                                <td class="center bordered bold"><xsl:value-of select="@Gris"/></td>
                                <td class="center bordered bold"><xsl:value-of select="@Gris"/></td>
                            </xsl:when>
                            <xsl:otherwise>
                                <td class="bordureRight"><xsl:value-of select="@LibelleBC"/></td>
                                <td class="center bordureRight"><xsl:value-of select="@Gris"/></td>
                                <td class="center bordureRight"><xsl:value-of select="@Gris"/></td>
                                <td class="center bordureRight"><xsl:value-of select="@Gris"/></td>
                                <td class="center bordureRight"><xsl:value-of select="@Gris"/></td>
                            </xsl:otherwise>
                        </xsl:choose>

                    </tr>
                </xsl:for-each>
            </tbody>
        </table>
    </xsl:template>
    
    <xsl:template name="mainTable.c2">
        <xsl:param name="el"/>
        <table width="100%" id="main" class="bordered">
            <colgroup>
                <col width="10%"/>
                <col width="6%"/>
                <col width="4%"/>
                <col width="4%"/>
                <col width="4%"/>
                <col width="4%"/>
                <col width="4%"/>
                <col width="4%"/>
                <col width="4%"/>
                <col width="4%"/>
                <col width="4%"/>
                <col width="4%"/>
                <col width="4%"/>
                <col width="4%"/>
                <col width="4%"/>
                <col width="4%"/>
                <col width="4%"/>
                <col width="4%"/>
                <col width="4%"/>
                <col width="8%"/>
                <col width="8%"/>
                
            </colgroup>
            <thead>
                <tr class="titre">
                    <td class="titre2 bold center bordered">Intitul des subdivisions</td>
                    <td class="titre2 bold center bordered">Rsultat comptable ou rsultat retenu par l&apos;autorit de tarification de l&apos;exercice <xsl:value-of select="$el/n:EnteteAffectationResultats/@ExerciceN_1"/></td>
                    <td colspan="6" class="titre2 bold center bordered">Reprise des rsultats antrieurs</td>
                    <td class="titre2 bold center bordered">Compte 1064<br/>"Rserve des plus-values nettes"</td>
                    <td class="titre2 bold center bordered">Compte 10682<br/>"Excdents affects  l&apos;investissement"</td>
                    <td class="titre2 bold center bordered">Compte 10685<br/>"Rserve de trsorerie"</td>
                    <td class="titre2 bold center bordered">Compte 10686<br/>"Rserve de comparaison"</td>
                    <td class="titre2 bold center bordered">Compte 10687<br/>"Rserve de comparaison des charges d&apos;amortissement"</td>
                    <td colspan="3" class="titre2 bold center bordered">Excdent restant  reporter</td>
                    <td colspan="3" class="titre2 bold center bordered">Dficite restant  reporter</td>
                    <td class="titre2 bold center bordered">Dpenses de l&apos;exercice <xsl:value-of select="$el/n:EnteteAffectationResultats/@ExerciceN_1"/> refuses par l&apos;autorit de tarification</td>
                    <td class="titre2 bold center bordered">Compte 116<br/>"Amortissements comptables excdentaires diffrs"</td>
                </tr>
                <tr>
                    <td class="bordered">&nbsp;</td>
                    <td class="bordered">&nbsp;</td>
                    <td class="titre3 bold center bordered">Excdents 110...</td>
                    <td class="titre3 bold center bordered">Excdents 110...</td>
                    <td class="titre3 bold center bordered">Excdents 111...</td>
                    <td class="titre3 bold center bordered">Excdents 119...</td>
                    <td class="titre3 bold center bordered">Excdents 119...</td>
                    <td class="titre3 bold center bordered">Excdents 119...</td>
                    <td class="bordered">&nbsp;</td>
                    <td class="bordered">&nbsp;</td>
                    <td class="bordered">&nbsp;</td>
                    <td class="bordered">&nbsp;</td>
                    <td class="bordered">&nbsp;</td>
                    <td class="titre3 bold center bordered">Sur l&apos;exercie ...<br/>Compte 110...<br/>"Report  nouveau (solde crditeur)"</td>
                    <td class="titre3 bold center bordered">Sur l&apos;exercie ...<br/>Compte 111...<br/>"Report  nouveau (solde crditeur)"</td>
                    <td class="titre3 bold center bordered">Sur l&apos;exercie ...<br/>Compte 110...<br/>"Report  nouveau (solde crditeur)"</td>
                    <td class="titre3 bold center bordered">Sur l&apos;exercie ...<br/>Compte 119...<br/>"Report  nouveau (solde crditeur)"</td>
                    <td class="titre3 bold center bordered">Sur l&apos;exercie ...<br/>Compte 119...<br/>"Report  nouveau (solde crditeur)"</td>
                    <td class="titre3 bold center bordered">Sur l&apos;exercie ...<br/>Compte 119...<br/>"Report  nouveau (solde crditeur)"</td>
                    <td class="titre3 bold center bordered">Sur l&apos;exercie ...<br/>Compte 114...<br/>"Dpenses refuses par l&apos;autorit de tarification en application de l&apos;article 51 du dcret n2003-1010"</td>
                    <td class="bordered">&nbsp;</td>
                </tr>
            </thead>
            <tbody>
                <xsl:for-each select="$el/n:LigneAffectationResultats">
                    <tr>
                        <xsl:choose>
                            <xsl:when test="$generated.id!='0' and @added:generated-id=$generated.id">
                                <xsl:attribute name="id">highlighted</xsl:attribute>
                            </xsl:when>
                            <xsl:otherwise>
                                <xsl:choose>
                                    <xsl:when test="(position() mod 2) = 0">
                                        <xsl:attribute name="id">colorised1</xsl:attribute>
                                    </xsl:when>
                                    <xsl:otherwise>
                                        <xsl:attribute name="id">colorised2</xsl:attribute>
                                    </xsl:otherwise>
                                </xsl:choose>
                            </xsl:otherwise>
                        </xsl:choose>
                        <xsl:choose>
                            <xsl:when test="contains(lower-case(@LibelleBC),'total')">
                                <td class="right bordered bold"><xsl:value-of select="@LibelleBC"/></td>
                                <td class="center bordered bold">&nbsp;</td>
                                <td class="center bordered bold"><xsl:value-of select="@Gris"/></td>
                                <td class="center bordered bold"><xsl:value-of select="@Gris"/></td>
                                <td class="center bordered bold"><xsl:value-of select="@Gris"/></td>
                                <td class="center bordered bold"><xsl:value-of select="@Gris"/></td>
                                <td class="center bordered bold"><xsl:value-of select="@Gris"/></td>
                                <td class="center bordered bold"><xsl:value-of select="@Gris"/></td>
                                <td class="center bordered bold"><xsl:value-of select="@Gris"/></td>
                                <td class="center bordered bold"><xsl:value-of select="@Gris"/></td>
                                <td class="center bordered bold"><xsl:value-of select="@Gris"/></td>
                                <td class="center bordered bold"><xsl:value-of select="@Gris"/></td>
                                <td class="center bordered bold"><xsl:value-of select="@Gris"/></td>
                                <td class="center bordered bold"><xsl:value-of select="@Gris"/></td>
                                <td class="center bordered bold"><xsl:value-of select="@Gris"/></td>
                                <td class="center bordered bold"><xsl:value-of select="@Gris"/></td>
                                <td class="center bordered bold"><xsl:value-of select="@Gris"/></td>
                                <td class="center bordered bold"><xsl:value-of select="@Gris"/></td>
                                <td class="center bordered bold"><xsl:value-of select="@Gris"/></td>
                                <td class="center bordered bold"><xsl:value-of select="@Gris"/></td>
                                <td class="center bordered bold"><xsl:value-of select="@Gris"/></td>
                            </xsl:when>
                            <xsl:otherwise>
                                <td class="bordureRight"><xsl:value-of select="@LibelleBC"/></td>
                                <td class="center bordureRight">&nbsp;</td>
                                <td class="center bordureRight"><xsl:value-of select="@Gris"/></td>
                                <td class="center bordureRight"><xsl:value-of select="@Gris"/></td>
                                <td class="center bordureRight"><xsl:value-of select="@Gris"/></td>
                                <td class="center bordureRight"><xsl:value-of select="@Gris"/></td>
                                <td class="center bordureRight"><xsl:value-of select="@Gris"/></td>
                                <td class="center bordureRight"><xsl:value-of select="@Gris"/></td>
                                <td class="center bordureRight"><xsl:value-of select="@Gris"/></td>
                                <td class="center bordureRight"><xsl:value-of select="@Gris"/></td>
                                <td class="center bordureRight"><xsl:value-of select="@Gris"/></td>
                                <td class="center bordureRight"><xsl:value-of select="@Gris"/></td>
                                <td class="center bordureRight"><xsl:value-of select="@Gris"/></td>
                                <td class="center bordureRight"><xsl:value-of select="@Gris"/></td>
                                <td class="center bordureRight"><xsl:value-of select="@Gris"/></td>
                                <td class="center bordureRight"><xsl:value-of select="@Gris"/></td>
                                <td class="center bordureRight"><xsl:value-of select="@Gris"/></td>
                                <td class="center bordureRight"><xsl:value-of select="@Gris"/></td>
                                <td class="center bordureRight"><xsl:value-of select="@Gris"/></td>
                                <td class="center bordureRight"><xsl:value-of select="@Gris"/></td>
                                <td class="center bordureRight"><xsl:value-of select="@Gris"/></td>
                            </xsl:otherwise>
                        </xsl:choose>
                        
                    </tr>
                </xsl:for-each>
            </tbody>
        </table>
    </xsl:template>
    
    <xsl:template name="mainTable.c3">
        <xsl:param name="el"/>
        <table width="100%" id="main" class="bordered">
            <colgroup>
                <col width="17%"/>
                <col width="7%"/>
                <col width="7%"/>
                <col width="7%"/>
                <col width="10%"/>
                <col width="7%"/>
                <col width="7%"/>
                <col width="7%"/>
                <col width="7%"/>
                <col width="7%"/>
                <col width="7%"/>
                <col width="10%"/>
                
            </colgroup>
            <thead>
                <tr class="titre">
                    <td rowspan="3" class="titre bold center bordered">Intitul des subdivisions</td>
                    <td colspan="3" class="titre bold center bordered">Compte 110</td>
                    <td class="titre bold center bordered">Compte 111</td>
                    <td colspan="6" class="titre bold center bordered">Compte 119</td>
                    <td class="titre bold center bordered">Compte 114</td>
                </tr>
                <tr>
                    <td colspan="3" class="titre2 bold center bordered">"Report  nouveau (solde crditeur)"<br/>Excdent restant  reporter</td>
                    <td class="titre2 bold center bordered">"Excdent affect  des mesures d&apos;exploitation non reconductibles"<br/>Excdent restant  reporter</td>
                    <td colspan="6" class="titre2 bold center bordered">"Report  nouveau (solde dbiteur)"<br/>Dficit restant  reporter</td>
                    <td rowspan="2" class="titre2 bold center bordered">Dpenses refuses au titre de l&apos;article 51 du dcret n2003-1010</td>
                </tr>
                <tr>
                    <td class="titre2 bold center bordered">Sur l&apos;exercice...<br/>110...</td>
                    <td class="titre2 bold center bordered">Sur l&apos;exercice...<br/>110...</td>
                    <td class="titre2 bold center bordered">Sur l&apos;exercice...<br/>110...</td>
                    <td class="titre2 bold center bordered">Sur l&apos;exercice...<br/>111...</td>
                    <td class="titre2 bold center bordered">Sur l&apos;exercice...<br/>119...</td>
                    <td class="titre2 bold center bordered">Sur l&apos;exercice...<br/>119...</td>
                    <td class="titre2 bold center bordered">Sur l&apos;exercice...<br/>119...</td>
                    <td class="titre2 bold center bordered">Sur l&apos;exercice...<br/>119...</td>
                    <td class="titre2 bold center bordered">Sur l&apos;exercice...<br/>119...</td>
                    <td class="titre2 bold center bordered">Sur l&apos;exercice...<br/>119...</td>
                </tr>
            </thead>
            <tbody>
                <xsl:for-each select="$el/n:LigneAffectationResultats">
                    <tr>
                        <xsl:choose>
                            <xsl:when test="$generated.id!='0' and @added:generated-id=$generated.id">
                                <xsl:attribute name="id">highlighted</xsl:attribute>
                            </xsl:when>
                            <xsl:otherwise>
                                <xsl:choose>
                                    <xsl:when test="(position() mod 2) = 0">
                                        <xsl:attribute name="id">colorised1</xsl:attribute>
                                    </xsl:when>
                                    <xsl:otherwise>
                                        <xsl:attribute name="id">colorised2</xsl:attribute>
                                    </xsl:otherwise>
                                </xsl:choose>
                            </xsl:otherwise>
                        </xsl:choose>
                        <xsl:choose>
                            <xsl:when test="contains(lower-case(@LibelleBC),'total')">
                                <td class="right bordered bold"><xsl:value-of select="@LibelleBC"/></td>
                                <td class="center bordered bold"><xsl:value-of select="@Gris"/></td>
                                <td class="center bordered bold"><xsl:value-of select="@Gris"/></td>
                                <td class="center bordered bold"><xsl:value-of select="@Gris"/></td>
                                <td class="center bordered bold"><xsl:value-of select="@Gris"/></td>
                                <td class="center bordered bold"><xsl:value-of select="@Gris"/></td>
                                <td class="center bordered bold"><xsl:value-of select="@Gris"/></td>
                                <td class="center bordered bold"><xsl:value-of select="@Gris"/></td>
                                <td class="center bordered bold"><xsl:value-of select="@Gris"/></td>
                                <td class="center bordered bold"><xsl:value-of select="@Gris"/></td>
                                <td class="center bordered bold"><xsl:value-of select="@Gris"/></td>
                                <td class="center bordered bold"><xsl:value-of select="@Gris"/></td>
                            </xsl:when>
                            <xsl:otherwise>
                                <td class="bordureRight"><xsl:value-of select="@LibelleBC"/></td>
                                <td class="center bordureRight"><xsl:value-of select="@Gris"/></td>
                                <td class="center bordureRight"><xsl:value-of select="@Gris"/></td>
                                <td class="center bordureRight"><xsl:value-of select="@Gris"/></td>
                                <td class="center bordureRight"><xsl:value-of select="@Gris"/></td>
                                <td class="center bordureRight"><xsl:value-of select="@Gris"/></td>
                                <td class="center bordureRight"><xsl:value-of select="@Gris"/></td>
                                <td class="center bordureRight"><xsl:value-of select="@Gris"/></td>
                                <td class="center bordureRight"><xsl:value-of select="@Gris"/></td>
                                <td class="center bordureRight"><xsl:value-of select="@Gris"/></td>
                                <td class="center bordureRight"><xsl:value-of select="@Gris"/></td>
                                <td class="center bordureRight"><xsl:value-of select="@Gris"/></td>
                            </xsl:otherwise>
                        </xsl:choose>
                        
                    </tr>
                </xsl:for-each>
            </tbody>
        </table>
    </xsl:template>

</xsl:stylesheet>
