<?xml version="1.0" encoding="ISO-8859-1"?>
<!DOCTYPE xsl:stylesheet [
<!ENTITY nbsp "&#160;">
<!ENTITY egrave "&#232;">
<!ENTITY euro "&#8364;">
<!ENTITY agrave "&#224;">
<!ENTITY eacute "&#233;">
]>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns="http://www.xemelios.org/namespaces#cg-1.0" xmlns:n="http://www.xemelios.org/namespaces#cg-1.0" version="2.0">
    <!-- Paramtres de sortie -->
    <xsl:character-map name="accents">
        <xsl:output-character character="" string="&amp;#224;"/>
        <xsl:output-character character="" string="&amp;#233;"/>
        <xsl:output-character character="" string="&amp;#232;"/>
        <xsl:output-character character="" string="&amp;#234;"/>
        <xsl:output-character character="" string="&amp;#235;"/>
        <xsl:output-character character="" string="&amp;#238;"/>
        <xsl:output-character character="" string="&amp;#239;"/>
        <xsl:output-character character="" string="&amp;#244;"/>
        <xsl:output-character character="" string="&amp;#249;"/>
    </xsl:character-map>
    <xsl:output method="xhtml" indent="yes" use-character-maps="accents" encoding="ISO-8859-1"/>
    <xsl:decimal-format name="decformat" decimal-separator="," grouping-separator=" " digit="#" pattern-separator=";" NaN="NaN" minus-sign="-"/>

    <!-- Inclusion des XSL externes -->
    <xsl:include href="./common-xsl/Style.xsl"/>
    <xsl:include href="./common-xsl/Error.xsl"/>
    <xsl:include href="./common-xsl/Navigate.xsl"/>
    <xsl:include href="./common-xsl/Header.xsl"/>
    <xsl:include href="./common-xsl/Number.xsl"/>

    <!-- Paramtres d'entre -->
    <xsl:param name="show.formulaire"/>
    <xsl:param name="browser-destination"/>

    <!-- Paramtres d'entre de la liste de rsultat -->
    <xsl:param name="numCompte">0</xsl:param>

    <!-- Paramtres d'erreur -->
    <xsl:param name="error.message">nomessage</xsl:param>

    <!-- Variables -->
    <xsl:variable name="page-format" select="paysage"/>
    <xsl:variable name="NumPage" select="/n:CompteGestion/n:BalanceValeursInactives/n:PageBalanceValeursInactives/n:Pied/@NumPage"/>
    <xsl:variable name="Entete">
        <xsl:copy-of select="/n:CompteGestion/n:Entete"/>
    </xsl:variable>

    <!-- pour eviter les sorties parasites de tags non matches -->
    <xsl:template match="*"/>

    <xsl:template match="/n:CompteGestion">
        <html>
            <head>
                <title>Balance des valeurs inactives</title>
                <xsl:call-template name="style"/>
            </head>
            <body width="100%">
                <xsl:if test="$error.message!='nomessage'">
                    <xsl:attribute name="onload">javascript:showDialog('<xsl:value-of select="$error.message"/>');</xsl:attribute>
                </xsl:if>
                <xsl:call-template name="Error"><!--xsl:with-param name="error.message" select="$error.message"/--></xsl:call-template>
                <xsl:call-template name="navigate">
                    <xsl:with-param name="docId">compteGestion</xsl:with-param>
                    <xsl:with-param name="etatId">BalanceValeursInactives</xsl:with-param>
                    <xsl:with-param name="elementId">PageBalanceValeursInactives</xsl:with-param>
                    <xsl:with-param name="sous.elementId">LigneBalanceValeursInactives</xsl:with-param>
                    <xsl:with-param name="NumPage" select="$NumPage"/>
                    <xsl:with-param name="Entete" select="$Entete"/>
                    <xsl:with-param name="show.formulaire" select="$show.formulaire"/>
                    <xsl:with-param name="show.formulaire.compte" select="0"/>
                    <xsl:with-param name="show.depense.recette" select="0"/>
                </xsl:call-template>
                <br/>
                <br/>
                <br/>
                <xsl:call-template name="header">
                    <xsl:with-param name="Entete" select="$Entete"/>
                    <xsl:with-param name="Titre">Balance des valeurs inactives</xsl:with-param>
                </xsl:call-template>
                <br/>
                <br/>
                <br/>
                <br/>
                <xsl:call-template name="mainTable">
                    <xsl:with-param name="el" select="/n:CompteGestion/n:BalanceValeursInactives/n:PageBalanceValeursInactives"/>
                </xsl:call-template>
                <br/>
                <br/>
                <br/>
                <br/>
                <p>
                    <center>Page - <xsl:value-of select="$NumPage"/></center>
                </p>
            </body>
        </html>
    </xsl:template>

    <xsl:template name="mainTable">
        <xsl:param name="el"/>
        <table width="100%" id="main" class="bordered">
            <colgroup>
                <col width="20%"/>
                <col width="10%"/>
                <col width="10%"/>
                <col width="10%"/>
                <col width="10%"/>
                <col width="10%"/>
                <col width="10%"/>
                <col width="10%"/>
                <col width="10%"/>

            </colgroup>
            <thead>
                <tr class="titre">
                    <td class="titre bold center bordered">DESIGNATION DES COMPTES</td>
                    <td colspan="3" class="titre bold center bordered">DEBIT</td>
                    <td colspan="3" class="titre bold center bordered">CREDIT</td>
                    <td colspan="2" class="titre bold center bordered">SOLDES</td>
                </tr>
                <tr>
                    <td class="titre2 bold center bordered">N<br/>Intitul&#233;</td>
                    <td class="titre2 bold center bordered">Balance d&#146;entr&#233;e</td>
                    <td class="titre2 bold center bordered">Ann&#233;e en cours</td>
                    <td class="titre2 bold center bordered">TOTAL</td>
                    <td class="titre2 bold center bordered">Balance d&#146;entr&#233;e</td>
                    <td class="titre2 bold center bordered">Ann&#233;e en cours</td>
                    <td class="titre2 bold center bordered">TOTAL</td>
                    <td class="titre2 bold center bordered">D&#233;biteurs</td>
                    <td class="titre2 bold center bordered">Cr&#233;diteurs</td>
                </tr>
            </thead>
            <tbody>
                <xsl:for-each select="$el/n:LigneBalanceValeursInactives">
                    <tr>
                        <xsl:choose>
                            <xsl:when test="(position() mod 2) = 0">
                                <xsl:attribute name="id">colorised1</xsl:attribute>
                            </xsl:when>
                            <xsl:otherwise>
                                <xsl:attribute name="id">colorised2</xsl:attribute>
                            </xsl:otherwise>
                        </xsl:choose>

                        <td class="bordureRight">
                            <xsl:value-of select="@NumCompte"/>
                            <br/>
                            <xsl:value-of select="@LibelleCompte"/>
                        </td>
                        <td class="center bordureRight">
                            <xsl:call-template name="number">
                                <xsl:with-param name="num" select="@MontantDebBe"/>
                            </xsl:call-template>
                        </td>
                        <td class="center bordureRight">
                            <xsl:call-template name="number">
                                <xsl:with-param name="num" select="@MontantDebAc"/>
                            </xsl:call-template>
                        </td>
                        <td class="center bordureRight">
                            <xsl:call-template name="number">
                                <xsl:with-param name="num" select="@MontantTotDeb"/>
                            </xsl:call-template>
                        </td>
                        <td class="center bordureRight">
                            <xsl:call-template name="number">
                                <xsl:with-param name="num" select="@MontantCreBe"/>
                            </xsl:call-template>
                        </td>
                        <td class="center bordureRight">
                            <xsl:call-template name="number">
                                <xsl:with-param name="num" select="@MontantCreAc"/>
                            </xsl:call-template>
                        </td>
                        <td class="center bordureRight">
                            <xsl:call-template name="number">
                                <xsl:with-param name="num" select="@MontantTotCre"/>
                            </xsl:call-template>
                        </td>
                        <td class="center bordureRight">
                            <xsl:call-template name="number">
                                <xsl:with-param name="num" select="@MontantSdDeb"/>
                            </xsl:call-template>
                        </td>
                        <td class="center bordureRight">
                            <xsl:call-template name="number">
                                <xsl:with-param name="num" select="@MontantSdCre"/>
                            </xsl:call-template>
                        </td>

                    </tr>
                </xsl:for-each>
            </tbody>
        </table>
    </xsl:template>

</xsl:stylesheet>
