<?xml version="1.0" encoding="ISO-8859-1"?>
<!DOCTYPE xsl:stylesheet [
<!ENTITY nbsp "&#160;">
<!ENTITY egrave "&#232;">
<!ENTITY euro "&#8364;">
<!ENTITY agrave "&#224;">
<!ENTITY eacute "&#233;">
]>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns="http://www.xemelios.org/namespaces#cg-1.0" xmlns:n="http://www.xemelios.org/namespaces#cg-1.0" version="2.0">
    <!-- Paramtres de sortie -->
    <xsl:character-map name="accents">
        <xsl:output-character character="" string="&amp;#224;"/>
        <xsl:output-character character="" string="&amp;#233;"/>
        <xsl:output-character character="" string="&amp;#232;"/>
        <xsl:output-character character="" string="&amp;#234;"/>
        <xsl:output-character character="" string="&amp;#235;"/>
        <xsl:output-character character="" string="&amp;#238;"/>
        <xsl:output-character character="" string="&amp;#239;"/>
        <xsl:output-character character="" string="&amp;#244;"/>
        <xsl:output-character character="" string="&amp;#249;"/>
    </xsl:character-map>
    <xsl:output method="xhtml" indent="yes" use-character-maps="accents" encoding="ISO-8859-1"/>
    <xsl:decimal-format name="decformat" decimal-separator="," grouping-separator=" " digit="#" pattern-separator=";" NaN="NaN" minus-sign="-"/>
    
    <!-- Inclusion des XSL externes -->
    <xsl:include href="./common-xsl/Style.xsl"/>
    <xsl:include href="./common-xsl/Error.xsl"/>
    <xsl:include href="./common-xsl/Navigate.xsl"/>
    <xsl:include href="./common-xsl/Header.xsl"/>
    <xsl:include href="./common-xsl/Number.xsl"/>
    
    <!-- Paramtres d'entre -->
    <xsl:param name="show.formulaire"/>
    <xsl:param name="browser-destination"/>
    
    <!-- Paramtres d'entre de la liste de rsultat -->
    <xsl:param name="Rubrique">0</xsl:param>
    
    <!-- Paramtres d'erreur -->
    <xsl:param name="error.message">nomessage</xsl:param>
    
    <!-- Variables -->
    <xsl:variable name="page-format" select="paysage"/>
    <xsl:variable name="NumPage" select="/n:CompteGestion/n:PresentationCroisee/n:PagePresentationCroisee/n:Pied/@NumPage"/>
    <xsl:variable name="Entete">
        <xsl:copy-of select="/n:CompteGestion/n:Entete"/>
    </xsl:variable>    
    
    <!-- pour eviter les sorties parasites de tags non matches -->
    <xsl:template match="*"/>
    
    <xsl:template match="/n:CompteGestion">
        <html>
            <head>
                <title>Etat D&#233;taill&#233;</title>
                <xsl:call-template name="style"/>
            </head>
            <body width="100%">
               <xsl:if test="$error.message!='nomessage'">
                    <xsl:attribute name="onload">javascript:showDialog('<xsl:value-of select="$error.message"/>');</xsl:attribute>
                </xsl:if>
                <xsl:call-template name="Error"><!--xsl:with-param name="error.message" select="$error.message"/--></xsl:call-template>
                <xsl:call-template name="navigate">
                    <xsl:with-param name="docId">compteGestion</xsl:with-param>
                    <xsl:with-param name="etatId">PresentationCroisee</xsl:with-param>
                    <xsl:with-param name="elementId">PagePresentationCroisee</xsl:with-param>
                    <xsl:with-param name="NumPage" select="$NumPage"/>
                    <xsl:with-param name="Entete" select="$Entete"/>
                    <xsl:with-param name="show.formulaire" select="$show.formulaire"/>
                    <xsl:with-param name="show.depense.recette" select="0"/>
                    <xsl:with-param name="show.formulaire.compte" select="0"/>
                    <xsl:with-param name="element.path">n:EntetePresentationCroisee</xsl:with-param>
                    <xsl:with-param name="path.plus">&amp;sp1=<xsl:value-of select="//n:Entete/n:Infos/n:Collectivite/@Exercice"/></xsl:with-param>
                </xsl:call-template>
                <br/>
                <br/>
                <br/>
                <xsl:call-template name="header">
                    <xsl:with-param name="Entete" select="$Entete"/>
                    <xsl:with-param name="Titre"></xsl:with-param>
                    <xsl:with-param name="Titre.Plus">
                        <h1><xsl:choose><xsl:when test="n:PresentationCroisee/n:PagePresentationCroisee/@Modele='20' or n:PresentationCroisee/n:PagePresentationCroisee/@Modele='21'"><xsl:value-of select="n:PresentationCroisee/n:PagePresentationCroisee/n:EntetePresentationCroisee/@TypeEtat"/></xsl:when><xsl:otherwise>Etat D&#233;taill&#233;</xsl:otherwise></xsl:choose></h1>
                        <h2><xsl:value-of select="//n:EntetePresentationCroisee/@SensTypeSection"/></h2>
                        <h3><xsl:value-of select="//n:EntetePresentationCroisee/@NumFonctionLibelleFonction"/></h3>
                    </xsl:with-param>
                </xsl:call-template>
                <br/>
                <br/>
                <br/>
                <br/>
                <xsl:call-template name="mainTable">
                    <xsl:with-param name="el" select="n:PresentationCroisee/n:PagePresentationCroisee"/>
                </xsl:call-template>
                <br/>
                <br/>
                <br/>
                <br/>
                <p>
                    <center>Page - <xsl:value-of select="$NumPage"/></center>
                </p>
            </body>
        </html>
    </xsl:template>
    
    <xsl:template name="mainTable">
        <xsl:param name="el"/>
        <table width="100%" class="bordered" id="main">
            <colgroup>
                <col width="12%"/>
                <col width="8%"/>
                <col width="8%"/>
                <col width="8%"/>
                <col width="8%"/>
                <col width="8%"/>
                <col width="8%"/>
                <col width="8%"/>
                <col width="8%"/>
                <col width="8%"/>
                <col width="8%"/>
                <col width="8%"/>
            </colgroup>
            <thead>
                <tr>
                    <td class="titre bold center bordered"><xsl:value-of select="$el/n:LigneEntetePresentationCroisee/@TitreRubrique"/></td>
                    <td class="titre bold center bordered"><xsl:value-of select="$el/n:LigneEntetePresentationCroisee/@CompteFonction1"/><br/><xsl:value-of select="$el/n:LigneEntetePresentationCroisee/@Libelle1"/></td>
                    <td class="titre bold center bordered"><xsl:value-of select="$el/n:LigneEntetePresentationCroisee/@CompteFonction2"/><br/><xsl:value-of select="$el/n:LigneEntetePresentationCroisee/@Libelle2"/></td>
                    <td class="titre bold center bordered"><xsl:value-of select="$el/n:LigneEntetePresentationCroisee/@CompteFonction3"/><br/><xsl:value-of select="$el/n:LigneEntetePresentationCroisee/@Libelle3"/></td>
                    <td class="titre bold center bordered"><xsl:value-of select="$el/n:LigneEntetePresentationCroisee/@CompteFonction4"/><br/><xsl:value-of select="$el/n:LigneEntetePresentationCroisee/@Libelle4"/></td>
                    <td class="titre bold center bordered"><xsl:value-of select="$el/n:LigneEntetePresentationCroisee/@CompteFonction5"/><br/><xsl:value-of select="$el/n:LigneEntetePresentationCroisee/@Libelle5"/></td>
                    <td class="titre bold center bordered"><xsl:value-of select="$el/n:LigneEntetePresentationCroisee/@CompteFonction6"/><br/><xsl:value-of select="$el/n:LigneEntetePresentationCroisee/@Libelle6"/></td>
                    <td class="titre bold center bordered"><xsl:value-of select="$el/n:LigneEntetePresentationCroisee/@CompteFonction7"/><br/><xsl:value-of select="$el/n:LigneEntetePresentationCroisee/@Libelle7"/></td>
                    <td class="titre bold center bordered"><xsl:value-of select="$el/n:LigneEntetePresentationCroisee/@CompteFonction8"/><br/><xsl:value-of select="$el/n:LigneEntetePresentationCroisee/@Libelle8"/></td>
                    <td class="titre bold center bordered"><xsl:value-of select="$el/n:LigneEntetePresentationCroisee/@CompteFonction9"/><br/><xsl:value-of select="$el/n:LigneEntetePresentationCroisee/@Libelle9"/></td>
                    <td class="titre bold center bordered"><xsl:value-of select="$el/n:LigneEntetePresentationCroisee/@CompteFonction10"/><br/><xsl:value-of select="$el/n:LigneEntetePresentationCroisee/@Libelle10"/></td>
                    <td class="titre bold center bordered"><xsl:value-of select="$el/n:LigneEntetePresentationCroisee/@CompteFonction11"/><br/><xsl:value-of select="$el/n:LigneEntetePresentationCroisee/@Libelle11"/></td>
                </tr>
            </thead>
            <tbody>
                <xsl:for-each select="$el/n:LignePresentationCroisee">
                    <tr>
                        <xsl:choose>
                            <xsl:when test="$Rubrique != '0' and @Rubrique=$Rubrique">
                                <xsl:attribute name="id">highlighted</xsl:attribute>
                            </xsl:when>
                            <xsl:otherwise>
                                <xsl:choose>
                                    <xsl:when test="(position() mod 2) = 0">
                                        <xsl:attribute name="id">colorised1</xsl:attribute>
                                    </xsl:when>
                                    <xsl:otherwise>
                                        <xsl:attribute name="id">colorised2</xsl:attribute>
                                    </xsl:otherwise>
                                </xsl:choose>
                            </xsl:otherwise>
                        </xsl:choose>
                        <xsl:choose>
                            <xsl:when test="contains(lower-case(@Rubrique),'total') or contains(lower-case(@Rubrique),'depenses') or contains(lower-case(@Rubrique),'recettes') or contains(lower-case(@LibelleRubrique),'solde')">
                                <td class="bold bordered"><xsl:value-of select="@Rubrique"/><br/><xsl:value-of select="@LibelleRubrique"/></td>
                                <td class="bold montant bordered"><xsl:call-template name="number"><xsl:with-param name="num" select="@Montant1"/></xsl:call-template></td>
                                <td class="bold montant bordered"><xsl:call-template name="number"><xsl:with-param name="num" select="@Montant2"/></xsl:call-template></td>
                                <td class="bold montant bordered"><xsl:call-template name="number"><xsl:with-param name="num" select="@Montant3"/></xsl:call-template></td>
                                <td class="bold montant bordered"><xsl:call-template name="number"><xsl:with-param name="num" select="@Montant4"/></xsl:call-template></td>
                                <td class="bold montant bordered"><xsl:call-template name="number"><xsl:with-param name="num" select="@Montant5"/></xsl:call-template></td>
                                <td class="bold montant bordered"><xsl:call-template name="number"><xsl:with-param name="num" select="@Montant6"/></xsl:call-template></td>
                                <td class="bold montant bordered"><xsl:call-template name="number"><xsl:with-param name="num" select="@Montant7"/></xsl:call-template></td>
                                <td class="bold montant bordered"><xsl:call-template name="number"><xsl:with-param name="num" select="@Montant8"/></xsl:call-template></td>
                                <td class="bold montant bordered"><xsl:call-template name="number"><xsl:with-param name="num" select="@Montant9"/></xsl:call-template></td>
                                <td class="bold montant bordered"><xsl:call-template name="number"><xsl:with-param name="num" select="@Montant10"/></xsl:call-template></td>
                                <td class="bold montant bordered"><xsl:call-template name="number"><xsl:with-param name="num" select="@Montant11"/></xsl:call-template></td>
                            </xsl:when>
                            <xsl:otherwise>
                                <td class="bold bordureRight"><xsl:value-of select="@Rubrique"/><br/><xsl:value-of select="@LibelleRubrique"/></td>
                                <td class="montant bordureRight"><xsl:call-template name="number"><xsl:with-param name="num" select="@Montant1"/></xsl:call-template></td>
                                <td class="montant bordureRight"><xsl:call-template name="number"><xsl:with-param name="num" select="@Montant2"/></xsl:call-template></td>
                                <td class="montant bordureRight"><xsl:call-template name="number"><xsl:with-param name="num" select="@Montant3"/></xsl:call-template></td>
                                <td class="montant bordureRight"><xsl:call-template name="number"><xsl:with-param name="num" select="@Montant4"/></xsl:call-template></td>
                                <td class="montant bordureRight"><xsl:call-template name="number"><xsl:with-param name="num" select="@Montant5"/></xsl:call-template></td>
                                <td class="montant bordureRight"><xsl:call-template name="number"><xsl:with-param name="num" select="@Montant6"/></xsl:call-template></td>
                                <td class="montant bordureRight"><xsl:call-template name="number"><xsl:with-param name="num" select="@Montant7"/></xsl:call-template></td>
                                <td class="montant bordureRight"><xsl:call-template name="number"><xsl:with-param name="num" select="@Montant8"/></xsl:call-template></td>
                                <td class="montant bordureRight"><xsl:call-template name="number"><xsl:with-param name="num" select="@Montant9"/></xsl:call-template></td>
                                <td class="montant bordureRight"><xsl:call-template name="number"><xsl:with-param name="num" select="@Montant10"/></xsl:call-template></td>
                                <td class="montant bordureRight"><xsl:call-template name="number"><xsl:with-param name="num" select="@Montant11"/></xsl:call-template></td>
                            </xsl:otherwise>
                        </xsl:choose>
                    </tr>
                </xsl:for-each>
            </tbody>            
        </table>
        <br/><xsl:value-of select="$el/VilleDate"/>
        <br/><xsl:value-of select="$el/Tresorier"/>
    </xsl:template>    
        
    <xsl:template name="iso-date">
        <xsl:param name="datebrute"/>
        <xsl:choose>
            <xsl:when test="string-length($datebrute)>0">        
                <xsl:value-of select="substring($datebrute, 9, 2)"/>
                <xsl:text>/</xsl:text>
                <xsl:value-of select="substring($datebrute,6,2)"/>
                <xsl:text>/</xsl:text>
                <xsl:value-of select="substring($datebrute, 1, 4)"/>
            </xsl:when>
            <xsl:otherwise>-</xsl:otherwise>
        </xsl:choose>
    </xsl:template>
</xsl:stylesheet>