<?xml version="1.0" encoding="ISO-8859-1"?>
<!DOCTYPE xsl:stylesheet [
<!ENTITY nbsp "&#160;">
<!ENTITY egrave "&#232;">
<!ENTITY euro "&#8364;">
<!ENTITY agrave "&#224;">
<!ENTITY eacute "&#233;">
]>
<xsl:transform xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns="http://www.xemelios.org/namespaces#cg-1.0" xmlns:n="http://www.xemelios.org/namespaces#cg-1.0" version="2.0">
    <xsl:character-map name="accents">
        <xsl:output-character character="" string="&amp;#224;"/>
        <xsl:output-character character="" string="&amp;#233;"/>
        <xsl:output-character character="" string="&amp;#232;"/>
        <xsl:output-character character="" string="&amp;#234;"/>
        <xsl:output-character character="" string="&amp;#235;"/>
        <xsl:output-character character="" string="&amp;#238;"/>
        <xsl:output-character character="" string="&amp;#239;"/>
        <xsl:output-character character="" string="&amp;#244;"/>
        <xsl:output-character character="" string="&amp;#249;"/>
    </xsl:character-map>
      <xsl:output method="xhtml" indent="yes" use-character-maps="accents" encoding="ISO-8859-1"/>
      <xsl:decimal-format name="decformat" decimal-separator="," grouping-separator=" " digit="#" pattern-separator=";" NaN="NaN" minus-sign="-"/> 
       <!-- Inclusion des XSL externes -->
    <xsl:include href="./common-xsl/Style.xsl"/>
    <xsl:include href="./common-xsl/Error.xsl"/>
    <xsl:include href="./common-xsl/Navigate.xsl"/>
    <xsl:include href="./common-xsl/Header.xsl"/>
    <xsl:include href="./common-xsl/Number.xsl"/>
    
    <!-- Paramtres d'entre -->
    <xsl:param name="show.formulaire"/>
    <xsl:param name="browser-destination"/>
    
    <!-- Paramtres d'entre de la liste de rsultat -->
    <xsl:param name="numCompte">0</xsl:param>
    
    <!-- Paramtres d'erreur -->
    <xsl:param name="error.message">nomessage</xsl:param>

    <!-- Variables -->
    <xsl:variable name="page-format" select="paysage"/>
    <xsl:variable name="NumPage" select="/n:CompteGestion/n:SP_BilanSynthetique/n:PageSP_BilanSynthetique/n:Pied/@NumPage"/>
    <xsl:variable name="Entete">
        <xsl:copy-of select="/n:CompteGestion/n:Entete"/>
    </xsl:variable>
    
    <!-- pour eviter les sorties parasites de tags non matches -->
    <xsl:template match="*"/>
    
 
    
    <xsl:template match="/n:CompteGestion">
        <html>
            <head>
                <title>Situation Patrimoniale - Bilan Synth&#233;tique</title>
                <xsl:call-template name="style"/>
            </head>
            <body>                
               <xsl:if test="$error.message!='nomessage'">
                    <xsl:attribute name="onload">javascript:showDialog('<xsl:value-of select="$error.message"/>');</xsl:attribute>
                </xsl:if>
                <xsl:call-template name="Error"><!--xsl:with-param name="error.message" select="$error.message"/--></xsl:call-template>
                <xsl:call-template name="navigate">
                    <xsl:with-param name="docId">compteGestion</xsl:with-param>
                    <xsl:with-param name="etatId">SP_BilanSynthetique</xsl:with-param>
                    <xsl:with-param name="elementId">PageSP_BilanSynthetique</xsl:with-param>
                    <xsl:with-param name="sous.elementId">LigneSP_BilanSynthetique</xsl:with-param>
                    <xsl:with-param name="NumPage" select="$NumPage"/>
                    <xsl:with-param name="Entete" select="$Entete"/>
                    <xsl:with-param name="show.formulaire" select="$show.formulaire"/>
                    <xsl:with-param name="show.formulaire.compte" select="0"/>
                    <xsl:with-param name="show.depense.recette" select="0"/>
                </xsl:call-template>
                <br/>
                <br/>
                <br/>
                <xsl:call-template name="header">
                    <xsl:with-param name="Entete" select="$Entete"/>
                    <xsl:with-param name="Titre">Situation Patrimoniale - Bilan Synthtique</xsl:with-param>
                </xsl:call-template>
                <br/><br/><br/><br/>
                <xsl:call-template name="mainTable">
                    <xsl:with-param name="el" select="/n:CompteGestion/n:SP_BilanSynthetique/n:PageSP_BilanSynthetique"/>
                </xsl:call-template>
                <br/><br/><br/><br/>
                <p>
                    <center>Page - <xsl:value-of select="/n:CompteGestion/n:SP_BilanSynthetique/n:PageSP_BilanSynthetique/n:Pied/@NumPage"/></center>
                </p>
            </body>
        </html>
    </xsl:template>
    
    <xsl:template name="mainTable">
        <xsl:param name="el"/>
        <xsl:for-each select="$el/n:LigneSP_BilanSynthetique">
            <table width="100%" class="bordered" id="main">
                <colgroup>
                    <col width="33%"/>
                    <col width="17%"/>
                    <col width="33%"/>
                    <col width="17%"/>
                </colgroup>
                <thead>
                    <tr class="titre">
                        <td class="bold titre center bordered">ACTIF NET<sup><small>1</small></sup></td>
                        <td class="bold titre center bordered">Total<br/><xsl:value-of select="$el/n:EnteteSP_BilanSynthetique/@Monnaie"/></td>
                        <td class="bold titre center bordered">PASSIF</td>
                        <td class="bold titre center bordered">Total<br/><xsl:value-of select="$el/n:EnteteSP_BilanSynthetique/@Monnaie"/></td>
                    </tr>
                </thead>
                <tbody>
                    <tr> <xsl:attribute name="id">colorised1</xsl:attribute>
                        <td class="bordered bold">Immobilisations incorporelles (nettes)</td>
                        <td class="bordered bold montant">
                            <xsl:call-template name="number">
                                <xsl:with-param name="num" select="@ImmobilisationsIncorporelles"/>
                            </xsl:call-template>
                        </td>
                        <td class="bordureRight">&nbsp;&nbsp;&nbsp;Dotations</td>
                        <td class="montant bordureRight">
                            <xsl:call-template name="number">
                                <xsl:with-param name="num" select="@Dotations"/>
                            </xsl:call-template>
                        </td>
                    </tr>
                    <tr> <xsl:attribute name="id">colorised2</xsl:attribute>
                        <td class="bordureRight">&nbsp;&nbsp;&nbsp;Terrains</td>
                        <td class="montant bordureRight">
                            <xsl:call-template name="number">
                                <xsl:with-param name="num" select="@Terrains"/>
                            </xsl:call-template>
                        </td>
                        <td class="bordureRight">&nbsp;&nbsp;&nbsp;Fonds Globalis&#233;s</td>
                            <td class="montant bordureRight">
                            <xsl:call-template name="number">
                                <xsl:with-param name="num" select="@FondsGlobalises"/>
                            </xsl:call-template>
                        </td>
                    </tr>
                    <tr> <xsl:attribute name="id">colorised1</xsl:attribute>
                        <td class="bordureRight">&nbsp;&nbsp;&nbsp;Constructions</td>
                        <td class="montant bordureRight">
                            <xsl:call-template name="number">
                                <xsl:with-param name="num" select="@Construction"/>
                            </xsl:call-template>
                        </td>
                        <td class="bordureRight">&nbsp;&nbsp;&nbsp;R&#233;serves</td>
                        <td class="montant bordureRight">
                            <xsl:call-template name="number">
                                <xsl:with-param name="num" select="@Reserves"/>
                            </xsl:call-template>
                        </td>
                    </tr>
                    <tr> <xsl:attribute name="id">colorised2</xsl:attribute>
                        <td class="bordureRight">&nbsp;&nbsp;&nbsp;R&#233;seaux et installations de voirie et r&#233;seaux divers</td>
                        <td class="montant bordureRight">
                            <xsl:call-template name="number">
                                <xsl:with-param name="num" select="@Reseaux"/>
                            </xsl:call-template>
                        </td>
                        <td class="bordureRight">&nbsp;&nbsp;&nbsp;Diff&#233;rences sur r&#233;alisations d&apos;immobilisations</td>
                        <td class="montant bordureRight">
                            <xsl:call-template name="number">
                                <xsl:with-param name="num" select="@DifferencesRealisations"/>
                            </xsl:call-template>
                        </td>
                    </tr>
                    <tr> <xsl:attribute name="id">colorised1</xsl:attribute>
                        <td class="bordureRight">&nbsp;&nbsp;&nbsp;Immobilisations corporelles en cours</td>
                        <td class="montant bordureRight">
                            <xsl:call-template name="number">
                                <xsl:with-param name="num" select="@ImmobilisationsEnCours"/>
                            </xsl:call-template>
                        </td>
                        <td class="bordureRight">&nbsp;&nbsp;&nbsp;Report &#224; nouveau</td>
                            <td class="montant bordureRight">
                            <xsl:call-template name="number">
                            <xsl:with-param name="num" select="@Report"/>
                            </xsl:call-template>
                        </td>                        
                    </tr>
                    <tr> <xsl:attribute name="id">colorised2</xsl:attribute>
                        <td class="bordureRight">&nbsp;&nbsp;&nbsp;Immobilisations mises en concession, affermage ou &agrave; disposition et immobilisations affect&eacute;es</td>
                        <td class="montant bordureRight">
                            <xsl:call-template name="number">
                                <xsl:with-param name="num" select="@ImmobilisationsMisesEnConcession"/>
                            </xsl:call-template>
                        </td>
                        <td class="bordureRight">&nbsp;&nbsp;&nbsp;R&#233;sultat de l&apos;exercice</td>
                        <td class="montant bordureRight">
                            <xsl:call-template name="number">
                                <xsl:with-param name="num" select="@Resultat"/>
                            </xsl:call-template>
                        </td>
                    </tr>
                    <tr> <xsl:attribute name="id">colorised1</xsl:attribute>
                        <td class="bordureRight">&nbsp;&nbsp;&nbsp;Autres immobilisations corporelles</td>
                        <td class="montant bordureRight">
                            <xsl:call-template name="number">
                                <xsl:with-param name="num" select="@AutresImmobilisations"/>
                            </xsl:call-template>
                        </td>
                        <td class="bordureRight">&nbsp;&nbsp;&nbsp;Subventions transfrables</td>
                        <td class="montant bordureRight">
                            <xsl:call-template name="number">
                                <xsl:with-param name="num" select="@Subventions"/>
                            </xsl:call-template>
                        </td>
                    </tr>
                    <tr> <xsl:attribute name="id">colorised2</xsl:attribute>
                        <td class="bold bordureRight">&nbsp;&nbsp;Total immobilisations corporelles (nettes)</td>
                        <td class="montant bold bordureRight">
                            <xsl:call-template name="number">
                                <xsl:with-param name="num" select="@TotalImmo"/>
                            </xsl:call-template>
                        </td>
                        <td class="bordureRight">&nbsp;&nbsp;&nbsp;Subventions non transf&#233;rables</td>
                        <td class="montant bordureRight">
                            <xsl:call-template name="number">
                                <xsl:with-param name="num" select="@SubventionsNonTransferables"/>
                            </xsl:call-template>
                        </td>
                    </tr>
                    <tr> <xsl:attribute name="id">colorised1</xsl:attribute>
                        <td class="bold bordered">&nbsp;&nbsp;Immobilisations financi&#232;res</td>
                        <td class="montant bold bordered">
                            <xsl:call-template name="number">
                                <xsl:with-param name="num" select="@ImmobilisationsFinancieres"/>
                            </xsl:call-template>
                        </td>
                        <td class="bordureRight">&nbsp;&nbsp;&nbsp;Droits de l&apos;affectant, du conc&#233;dant, de l&apos;affermant et du remettant</td>
                        <td class="montant bordureRight">
                            <xsl:call-template name="number">
                                <xsl:with-param name="num" select="@DroitsAffectant"/>
                            </xsl:call-template>
                        </td>
                    </tr>
                    <tr> <xsl:attribute name="id">colorised2</xsl:attribute>
                        <td class="bold borderedBold">&nbsp;TOTAL ACTIF IMMOBILISE</td>
                        <td class="montant bold borderedBold">
                            <xsl:call-template name="number">
                                <xsl:with-param name="num" select="@TotalActifImmo"/>
                            </xsl:call-template>
                        </td>
                        <td class="bordureRight">&nbsp;&nbsp;&nbsp;Autres fonds propres</td>
                        <td class="montant bordureRight">
                            <xsl:call-template name="number">
                                <xsl:with-param name="num" select="@AutresFondsPropres"/>
                            </xsl:call-template>
                        </td>
                    </tr>
                    <tr> <xsl:attribute name="id">colorised1</xsl:attribute>
                        <td class="bordureRight">&nbsp;&nbsp;&nbsp;Stocks</td>
                        <td class="montant bordureRight">
                            <xsl:call-template name="number">
                                <xsl:with-param name="num" select="@Stocks"/>
                            </xsl:call-template>
                        </td>
                        <td class="bold borderedBold">&nbsp;TOTAL FONDS PROPRES</td>
                        <td class="montant bold borderedBold">
                            <xsl:call-template name="number">
                                <xsl:with-param name="num" select="@TotalFondsPropres"/>
                            </xsl:call-template>
                        </td>
                    </tr>
                    <tr> <xsl:attribute name="id">colorised2</xsl:attribute>
                        <td class="bordureRight">&nbsp;&nbsp;&nbsp;Cr&#233;ances</td>
                        <td class="montant bordureRight">
                            <xsl:call-template name="number">
                                <xsl:with-param name="num" select="@Creances"/>
                            </xsl:call-template>
                        </td>                        
                        <td class="bold borderedBold">&nbsp;PROVISIONS POUR RIQUES ET CHARGES</td>
                        <td class="montant bold borderedBold">
                            <xsl:call-template name="number">
                                <xsl:with-param name="num" select="@ProvisionsRetC"/>
                            </xsl:call-template>
                        </td>
                    </tr>
                    <tr> <xsl:attribute name="id">colorised1</xsl:attribute>
                        <td class="bordureRight">&nbsp;&nbsp;&nbsp;Valeurs mobili&#232;res de placement</td>
                        <td class="montant bordureRight">
                            <xsl:call-template name="number">
                                <xsl:with-param name="num" select="@VMP"/>
                            </xsl:call-template>
                        </td>
                        <td class="bold bordered">&nbsp;Dettes financi&#232;res &#224; long terme</td>
                        <td class="montant bold bordered">
                            <xsl:call-template name="number">
                                <xsl:with-param name="num" select="@DettesFiLongTerme"/>
                            </xsl:call-template>
                        </td>
                    </tr>
                    <tr> <xsl:attribute name="id">colorised2</xsl:attribute>
                        <td class="bordureRight">&nbsp;&nbsp;&nbsp;Disponibilit&#233;s</td>
                        <td class="montant bordureRight">
                            <xsl:call-template name="number">
                                <xsl:with-param name="num" select="@Disponibilites"/>
                            </xsl:call-template>
                        </td>                        
                        <td class="bordureRight">&nbsp;&nbsp;&nbsp;Fournisseurs <sup><small>(2)</small></sup></td>
                        <td class="montant bordureRight">
                            <xsl:call-template name="number">
                                <xsl:with-param name="num" select="@Fournisseurs"/>
                            </xsl:call-template>
                        </td>
                    </tr>
                    <tr> <xsl:attribute name="id">colorised1</xsl:attribute>
                        <td class="bordureRight">&nbsp;&nbsp;&nbsp;Autres actifs circulant</td>
                        <td class="montant bordureRight">
                            <xsl:call-template name="number">
                                <xsl:with-param name="num" select="@AutresActifsCirculant"/>
                            </xsl:call-template>
                        </td>
                        <td class="bordureRight">&nbsp;&nbsp;&nbsp;Autres dettes &#224; court terme</td>
                        <td class="montant bordureRight">
                            <xsl:call-template name="number">
                                <xsl:with-param name="num" select="@AutresDettes"/>
                            </xsl:call-template>
                        </td>
                    </tr>
                    <tr> <xsl:attribute name="id">colorised2</xsl:attribute>
                        <td class="bold bordureRight">&nbsp;TOTAL ACTIF CIRCULANT</td>
                        <td class="montant bold bordureRight">
                            <xsl:call-template name="number">
                                <xsl:with-param name="num" select="@TotalActifCirculant"/>
                            </xsl:call-template>
                        </td>
                        <td class="bold bordureRight bordureBottom">&nbsp;Total dettes &#224; court terme</td>
                        <td class="montant bold bordureRight bordureBottom">
                            <xsl:call-template name="number">
                                <xsl:with-param name="num" select="@TotalDettesCourtTerme"/>
                            </xsl:call-template>
                        </td>
                    </tr>
                    <tr> <xsl:attribute name="id">colorised1</xsl:attribute>
                        <td class="bold bordered">&nbsp;&nbsp;Comptes de r&#233;gularisations</td>
                        <td class="montant bold bordered">
                            <xsl:call-template name="number">
                                <xsl:with-param name="num" select="@CompteRegularisationActif"/>
                            </xsl:call-template>
                        </td>
                        <td class="bold bordureRight">&nbsp;TOTAL DETTES</td>
                        <td class="montant bold bordureRight">
                            <xsl:call-template name="number">
                                <xsl:with-param name="num" select="@TotalDettes"/>
                            </xsl:call-template>
                        </td>
                    </tr>
                    <tr> <xsl:attribute name="id">colorised2</xsl:attribute>
                        <td class="bordureRight">&nbsp;</td>
                        <td class="bordureRight">&nbsp;</td>
                        <td class="bold bordureRight">&nbsp;Comptes de rgularisations</td>
                        <td class="montant bold bordureRight">
                            <xsl:call-template name="number">
                                <xsl:with-param name="num" select="@CompteRegularisationPassif"/>
                            </xsl:call-template>
                        </td>
                    </tr>
                    <tr> <xsl:attribute name="id">colorised1</xsl:attribute>
                        <td class="bold bordureTopBold">&nbsp;TOTAL ACTIF</td>
                        <td class="montant bold bordureTopBold">
                            <xsl:call-template name="number">
                                <xsl:with-param name="num" select="@TotalActif"/>
                            </xsl:call-template>
                        </td>
                        <td class="bold bordureTopBold">&nbsp;&nbsp;&nbsp;TOTAL PASSIF</td>
                        <td class="montant bold bordureTopBold">
                            <xsl:call-template name="number">
                                <xsl:with-param name="num" select="@TotalPassif"/>
                            </xsl:call-template>
                        </td>
                    </tr>
                </tbody>
            </table>
        </xsl:for-each>
    </xsl:template>
</xsl:transform>