<?xml version="1.0" encoding="ISO-8859-1"?>
<!DOCTYPE xsl:stylesheet [
<!ENTITY nbsp "&#160;">
<!ENTITY egrave "&#232;">
<!ENTITY euro "&#8364;">
<!ENTITY agrave "&#224;">
<!ENTITY eacute "&#233;">
]>
<xsl:transform xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns="http://www.xemelios.org/namespaces#cge" xmlns:n="http://www.xemelios.org/namespaces#cge" xmlns:added="http://projets.admisource.gouv.fr/xemelios/namespaces#added" version="2.0">
    <xsl:character-map name="accents">
        <xsl:output-character character="" string="&amp;#224;"/>
        <xsl:output-character character="" string="&amp;#233;"/>
        <xsl:output-character character="" string="&amp;#232;"/>
        <xsl:output-character character="" string="&amp;#234;"/>
        <xsl:output-character character="" string="&amp;#235;"/>
        <xsl:output-character character="" string="&amp;#238;"/>
        <xsl:output-character character="" string="&amp;#239;"/>
        <xsl:output-character character="" string="&amp;#244;"/>
        <xsl:output-character character="" string="&amp;#249;"/>
    </xsl:character-map>

    <xsl:decimal-format name="decformat" decimal-separator="," grouping-separator=" " digit="#" pattern-separator=";" NaN="NaN" minus-sign="-"/>
    
    <!-- Inclusion des XSL externes -->
    <xsl:include href="./common-xsl/Style.xsl"/>
    <xsl:include href="./common-xsl/Error.xsl"/>
    <xsl:include href="./common-xsl/Navigate.xsl"/>
    <xsl:include href="./common-xsl/Header.xsl"/>
    <xsl:include href="./common-xsl/Number.xsl"/>
    
    <!-- Paramtres d'entre -->
    <xsl:param name="show.formulaire"/>
    <xsl:param name="browser-destination"/>
    
    <!-- Paramtres d'entre de la liste de rsultat -->
    <xsl:param name="libPoste">0</xsl:param>
    
    <!-- Paramtres d'erreur -->
    <xsl:param name="error.message">nomessage</xsl:param>

    <!-- Paramtres d'entre de la liste de rsultat -->
    <xsl:param name="numCompte">0</xsl:param>
    <xsl:param name="ministere">0</xsl:param>
    <xsl:param name="programme">0</xsl:param>
    <xsl:param name="article">0</xsl:param>

    <xsl:output method="xhtml" indent="yes" use-character-maps="accents" encoding="ISO-8859-1"/>

    <!-- pour eviter les sorties parasites de tags non matches -->
    <xsl:template match="*"/>
  <!-- Variables -->
    <xsl:variable name="page-format" select="paysage"/>
    <xsl:variable name="NumPage" select="/n:CompteGestionEtat/n:DeveloppementDepense/n:PageDeveloppementDepense/n:Pied/@NumPage"/>
    <xsl:variable name="Entete">
        <xsl:copy-of  select="/n:CompteGestionEtat/n:Entete"/>
    </xsl:variable>

    <xsl:template match="/n:CompteGestionEtat">
        <html>
            <head>
                <title>D&#233;veloppement des d&#233;penses budg&#233;taires par minist&#232;re et programme</title>                
                <xsl:call-template name="style"/>                
            </head>
            <body>
                <xsl:if test="$error.message!='nomessage'">
                    <xsl:attribute name="onload">javascript:showDialog('<xsl:value-of select="$error.message"/>');</xsl:attribute>
                </xsl:if>
                <xsl:call-template name="Error"><!--xsl:with-param name="error.message" select="$error.message"/--></xsl:call-template>
                <xsl:call-template name="navigate">
                    <xsl:with-param name="docId">compteGestionEtat</xsl:with-param>
                    <xsl:with-param name="etatId">DeveloppementDepense</xsl:with-param>
                    <xsl:with-param name="elementId">PageDeveloppementDepense</xsl:with-param>
                    <xsl:with-param name="sous.elementId">LigneDeveloppementDepense</xsl:with-param>
                    <xsl:with-param name="NumPage" select="$NumPage"/>
                    <xsl:with-param name="Entete" select="$Entete"/>
                    <xsl:with-param name="show.formulaire" select="$show.formulaire"/>
                    <xsl:with-param name="show.formulaire.compte" select="1"/>
                    <xsl:with-param name="show.depense.recette" select="0"/>
                </xsl:call-template>
                <xsl:call-template name="header" >
                    <xsl:with-param name="Entete" select="$Entete"/>
                </xsl:call-template>
                <br/>
                <br/>
                <br/>
                <br/>
                <xsl:call-template name="mainTable">
                    <xsl:with-param name="el" select="/n:CompteGestionEtat/n:DeveloppementDepense/n:PageDeveloppementDepense"/>
                </xsl:call-template>
                <br/>
                <br/>
                <br/>
                <br/>
                <p>
                    <center>Page - <xsl:value-of select="n:DeveloppementDepense/n:PageDeveloppementDepense/n:Pied/@NumPage"/></center>
                </p>
                <br/>
                <br/>
                <center>__________________________________________</center>
                <xsl:call-template name="navigate">
                    <xsl:with-param name="docId">compteGestionEtat</xsl:with-param>
                    <xsl:with-param name="etatId">DeveloppementDepense</xsl:with-param>
                    <xsl:with-param name="elementId">PageDeveloppementDepense</xsl:with-param>
                    <xsl:with-param name="sous.elementId">LigneDeveloppementDepense</xsl:with-param>
                    <xsl:with-param name="NumPage" select="$NumPage"/>
                    <xsl:with-param name="Entete" select="$Entete"/>
                    <xsl:with-param name="show.formulaire" select="$show.formulaire"/>
                    <xsl:with-param name="show.formulaire.compte" select="1"/>
                    <xsl:with-param name="show.depense.recette" select="0"/>
                    <xsl:with-param name="ancre">#footer</xsl:with-param>
                    <xsl:with-param name="display.logos.entete">0</xsl:with-param>
                </xsl:call-template>
                <p id="footer"/>
            </body>
        </html>
    </xsl:template>

    <xsl:template name="mainTable">
        <xsl:param name="el"/>
        <table width="100%" class="bordered" id="main">
            <colgroup>
                <col width="20%"/>
                <col width="25%"/>
                <col width="10%"/>
                <col width="20%"/>
                <col width="10%"/>
                <col width="15%"/>
            </colgroup>
            <thead>
                <tr  class="titre">
                    <td class="titre2 center bold bordered">Comptes</td>
                    <td class="titre2 center bold bordered">Montant OAD</td> 
                    <td class="titre2 center bold bordered">Minist&#232;re</td>
                    <td class="titre2 center bold bordered">Programmes</td>
                    <td class="titre2 center bold bordered">Article<br/>ex&#233;cution</td>
                    <td class="titre2 center bold bordered">D&#233;penses admises</td>
                </tr>
            </thead>
            <tbody>
                <xsl:variable name="nums.comptes" select="distinct-values($el/n:LigneDeveloppementDepense/@NumCompte)"/>
                <xsl:for-each select="$nums.comptes">
                    <xsl:sort select="."/>
                    <xsl:variable name="this.compte" select="."/>
                    <xsl:variable name="lignes.this.compte" select="$el/n:LigneDeveloppementDepense[@NumCompte=$this.compte]"/>
                    <xsl:variable name="nb.lignes.this.compte" select="count($lignes.this.compte)"/>
                    
                    <xsl:variable name="ministeres.lignes.this.compte" select="distinct-values($lignes.this.compte/@Ministere)"/>
                    
                    <xsl:variable name="min.ministere" select="min($lignes.this.compte/@Ministere)"/>
                    <xsl:variable name="min.ministere.lignes" select="$lignes.this.compte[number(@Ministere)=$min.ministere]"/>
                    
                    <xsl:variable name="min.article.ministere.lignes" select="min($min.ministere.lignes/@ArticleExec)"/>
                    
                    <xsl:variable name="first" select="$min.ministere.lignes[1]/@added:generated-id"/>
                    
                    
                    <xsl:variable name="position.compte" select="position()"/>
                    
                    
                    <tr class="mask">
                        <td class="titre center bold bordered">
                            <xsl:attribute name="rowspan" select="$nb.lignes.this.compte"/>
                            <h3 style="color: black;"><xsl:value-of select="."/></h3>
                        </td>
                        <td colspan="5">&#160;</td>
                    </tr>
                    <xsl:for-each select="$ministeres.lignes.this.compte">
                        <xsl:sort select="." data-type="text"/>
                        <xsl:variable name="this.ministere" select="."/>
                        <xsl:variable name="lignes.this.ministere" select="$lignes.this.compte[@Ministere=$this.ministere]"/>
                        
                        <xsl:variable name="position.ministere" select="position()"/>
                        
                        <xsl:variable name="programme.this.ministeres.lignes.this.compte" select="distinct-values($lignes.this.ministere/@Programme)"/>
                        
                        <xsl:for-each select="$programme.this.ministeres.lignes.this.compte">
                            <xsl:variable name="this.programme" select="."/>
                            <xsl:variable name="lignes.this.programme" select="$lignes.this.ministere[@Programme=$this.programme]"/>
                            
                            <xsl:for-each select="$lignes.this.programme[string-length(@ArticleExec) &gt; 0]">
                                <xsl:sort select="@ArticleExec" data-type="text"/>
                                <xsl:variable name="articleExec" select="@ArticleExec"/>
                                <xsl:variable name="position.programme" select="position()"/>
                                <tr>
                                    <xsl:choose>
                                        <xsl:when test="$numCompte != '0' and @NumCompte=$numCompte and $this.ministere=$ministere and $this.programme=$programme and $articleExec=$article">
                                            <xsl:attribute name="id">highlighted</xsl:attribute>
                                        </xsl:when>
                                        <xsl:otherwise>
                                            <xsl:choose>
                                                <xsl:when test="(position() mod 2) = 0">
                                                    <xsl:attribute name="id">colorised3</xsl:attribute>
                                                </xsl:when>
                                                <xsl:otherwise>
                                                    <xsl:attribute name="id">colorised2</xsl:attribute>
                                                </xsl:otherwise>
                                            </xsl:choose>
                                        </xsl:otherwise>
                                    </xsl:choose>
                                    
                                    <td class="montant bordered"><xsl:call-template name="number"><xsl:with-param name="num" select="@MtDebit"/></xsl:call-template> &euro;</td>
                                    <td class="bordered center"><xsl:value-of select="$this.ministere"/></td>
                                    <xsl:if test="$position.programme eq 1">
                                        <td class="bordered center">
                                            <xsl:attribute name="rowspan" select="count($lignes.this.programme) - 1"/>
                                            <xsl:value-of select="$this.programme"/>
                                        </td>
                                    </xsl:if>
                                    <td class="bordered center"><xsl:value-of select="@ArticleExec"/></td>
                                    <td class="montant bordered"><xsl:call-template name="number"><xsl:with-param name="num" select="@MtDebit"/></xsl:call-template> &euro;</td>
                                </tr>
                            </xsl:for-each>
                            <xsl:variable name="ligne.total.this.programme" select="$lignes.this.programme[string-length(@ArticleExec) eq 0]"/>
                            <tr>
                                <!--td class="libelleLigne bold bordered">&#160;<xsl:value-of select="$this.compte"/></td-->
                                <td class="bold bordered center totalAnnexeII" colspan="4">Total Programme <xsl:value-of select="$this.programme"/></td>
                                <td class="montant bold bordered totalAnnexeII"><xsl:call-template name="number"><xsl:with-param name="num" select="$ligne.total.this.programme/@MtDebit"/></xsl:call-template> &euro;</td>
                            </tr>
                        </xsl:for-each>
                    </xsl:for-each>
                    <xsl:variable name="ligne.total.this.compte" select="$lignes.this.compte[string-length(@Ministere) eq 0]"/>
                    <tr>
                        <td class="bold totalAnnexeII1 bordered right">Total du compte <xsl:value-of select="$this.compte"/></td>
                        <td class="montant bold bordered totalAnnexeII1"><xsl:call-template name="number"><xsl:with-param name="num" select="$ligne.total.this.compte/@MtDebit"/></xsl:call-template> &euro;</td>
                        <td class="montant bold bordered totalAnnexeII1" colspan="4"><xsl:call-template name="number"><xsl:with-param name="num" select="$ligne.total.this.compte/@MtDebit"/></xsl:call-template> &euro;</td>
                    </tr>
                </xsl:for-each>
            </tbody>
        </table>
    </xsl:template>
  
</xsl:transform>
