<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:n="http://www.minefi.gouv.fr/cp/helios/pes_v2/erar/r0/restit" xmlns="http://www.minefi.gouv.fr/cp/helios/pes_v2/erar/r0/restit" version="2.0">
    <xsl:param name="DEB_ID_TIERS"/>
    <xsl:param name="DEB_NOM"/>
    <xsl:param name="DEB_PRENOM"/>
    <xsl:param name="DEB_ADR1"/>
    <xsl:param name="DEB_ADR2"/>
    <xsl:param name="DEB_ADR3"/>
    <xsl:param name="DEB_CP"/>
    <xsl:param name="DEB_VILLE"/>
    <xsl:param name="somme"/>
    
    <xsl:output encoding="UTF-8" exclude-result-prefixes="xsl" method="xml" indent="yes"/>

    <xsl:template match="/">
        <PES_Restit>
            <PES_ERAR>
                <LigneERAR>
                    <xsl:if test="string-length($somme) &gt; 0">
                        <RarTotal V="{$somme}"/>
                    </xsl:if>
                    <Debiteur>
                        <InfoTiers>
                            <xsl:if test="string-length($DEB_ID_TIERS) &gt; 0">
                                <IdTiers V="{$DEB_ID_TIERS}"/>
                            </xsl:if>
                            <xsl:if test="string-length($DEB_NOM) &gt; 0">
                                <Nom V="{$DEB_NOM}"/>
                            </xsl:if>
                            <xsl:if test="string-length($DEB_PRENOM) &gt; 0">
                                <Prenom V="{$DEB_PRENOM}"/>
                            </xsl:if>
                        </InfoTiers>
                        <Adresse>
                            <xsl:if test="string-length($DEB_ADR1) &gt; 0">
                                <Adr1 V="{$DEB_ADR1}"/>
                            </xsl:if>
                            <xsl:if test="string-length($DEB_ADR2) &gt; 0">
                                <Adr1 V="{$DEB_ADR2}"/>
                            </xsl:if>
                            <xsl:if test="string-length($DEB_ADR3) &gt; 0">
                                <Adr1 V="{$DEB_ADR3}"/>
                            </xsl:if>
                            <xsl:if test="string-length($DEB_CP) &gt; 0">
                                <CP V="{$DEB_CP}"/>
                            </xsl:if>
                            <xsl:if test="string-length($DEB_VILLE) &gt; 0">
                                <Ville V="{$DEB_VILLE}"/>
                            </xsl:if>
                        </Adresse>
                    </Debiteur>
                </LigneERAR>
            </PES_ERAR>
        </PES_Restit>
    </xsl:template>
</xsl:stylesheet>
