<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="2.0">

    <xsl:character-map name="accents">
        <xsl:output-character character="à" string="&amp;#224;"/>
        <xsl:output-character character="é" string="&amp;#233;"/>
        <xsl:output-character character="è" string="&amp;#232;"/>
        <xsl:output-character character="ê" string="&amp;#234;"/>
        <xsl:output-character character="ë" string="&amp;#235;"/>
        <xsl:output-character character="î" string="&amp;#238;"/>
        <xsl:output-character character="ï" string="&amp;#239;"/>
        <xsl:output-character character="ô" string="&amp;#244;"/>
        <xsl:output-character character="ù" string="&amp;#249;"/>
    </xsl:character-map>
    
    <xsl:output method="xml" encoding="ISO-8859-1" indent="yes" use-character-maps="accents"/>
    
    <xsl:template match="processing-instruction()">
        <xsl:copy-of select="."/>
    </xsl:template>
    
    <xsl:template match="xhtml">
        <xsl:call-template name="writeElement">
            <xsl:with-param name="el" select="."/>
        </xsl:call-template>
    </xsl:template>
    
    <!--xsl:template match="*">
        <xsl:copy>
            <xsl:apply-templates/>
        </xsl:copy>
    </xsl:template-->
    
    <xsl:template name="writeElement">
        <xsl:param name="el"/>
            <xsl:choose>
                <xsl:when test="local-name($el)='li' and not($el/a/text()='EDMN')"></xsl:when>
                <xsl:otherwise>
                    <xsl:element name="{local-name($el)}" namespace="{namespace-uri($el)}">
                        <xsl:for-each select="$el/@*">
                        <xsl:attribute name="{local-name(.)}" namespace="{namespace-uri($el)}">
                            <xsl:value-of select="."/>
                        </xsl:attribute>
                    </xsl:for-each>
                    <xsl:for-each select="$el/*">
                        <xsl:call-template name="writeElement">
                            <xsl:with-param name="el" select="."/>
                        </xsl:call-template>
                    </xsl:for-each>
                    <xsl:value-of select="$el/text()"/>
                    </xsl:element>
                </xsl:otherwise>
            </xsl:choose>
            <!--xsl:value-of select="$el/text()"/-->
    </xsl:template>
    
</xsl:stylesheet>
