/*
 * Copyright 
 *   2007 axYus - www.axyus.com
 *   2007 N.Le Corre - nicolas.lecorre@axyus.com
 * 
 * This file is part of XEMELIOS.
 * 
 * XEMELIOS is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * XEMELIOS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with XEMELIOS; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package fr.gouv.finances.cp.xemelios.ui;

import fr.gouv.finances.cp.utils.ui.InfiniteGlassPane;
import fr.gouv.finances.dgfip.xemelios.auth.XemeliosUser;
import fr.gouv.finances.dgfip.xemelios.common.config.DocumentsModel;
import fr.gouv.finances.dgfip.xemelios.data.WaitableUI;
import java.awt.Cursor;

/**
 *
 * @author  nicolas.lecorre
 */
public abstract class DlgChooseDocuments extends javax.swing.JDialog implements WaitableUI {
	
	private DocumentsModel dm;
	private boolean selectionMultiple = true;
        private XemeliosUser user;

	public void setBActionLibelle(String actionLibelle) {
		bAction.setText(actionLibelle);
	}

	/**
	 * La mthode appele lors du click sur le bouton "action" en bas  droite.
	 * Cela peut tre la suppression, l'export, ...
	 * @param evt
	 */
	protected abstract void doAction (java.awt.event.ActionEvent evt);
    
    /** Creates new form DlgChooseDocuments */
    public DlgChooseDocuments(java.awt.Frame parent, boolean modal, DocumentsModel _dm, boolean selectionMultiple,XemeliosUser user) {
        super(parent, modal);
        this.user=user;
        this.selectionMultiple = selectionMultiple;
        this.setDm(_dm);
        initComponents();
        setLocationRelativeTo(getParent());
        setGlassPane(new InfiniteGlassPane());
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jTabbedPane1 = new javax.swing.JTabbedPane();
        jTabbedPane1.addTab("Par donnes", new PanelChooseDatabaseDonnees(this,dm,user));
        jTabbedPane1.addTab("Par fichier", new PanelChooseDatabaseFichier(this,dm,false,user));
        bFermer = new javax.swing.JButton();
        bAction = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);

        bFermer.setText("Fermer");
        bFermer.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bFermerActionPerformed(evt);
            }
        });

        bAction.setText("Action");
        bAction.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bActionActionPerformed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(jTabbedPane1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 636, Short.MAX_VALUE)
                    .add(layout.createSequentialGroup()
                        .add(bFermer)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(bAction)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(jTabbedPane1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 456, Short.MAX_VALUE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(bAction)
                    .add(bFermer))
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void bActionActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bActionActionPerformed
    	doAction (evt);
    }//GEN-LAST:event_bActionActionPerformed

    private void bFermerActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bFermerActionPerformed
    	this.dispose();
    }//GEN-LAST:event_bFermerActionPerformed
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton bAction;
    private javax.swing.JButton bFermer;
    private javax.swing.JTabbedPane jTabbedPane1;
    // End of variables declaration//GEN-END:variables

	public DocumentsModel getDm() {
		return dm;
	}

	public void setDm(DocumentsModel dm) {
		this.dm = dm;
	}

	public javax.swing.JTabbedPane getJTabbedPane1() {
		return jTabbedPane1;
	}
	
	public void enableButtons (boolean enable) {
		this.bAction.setEnabled(enable);
		this.bFermer.setEnabled(enable);
	}
    public void startWait() {
        setCursor(new Cursor(Cursor.WAIT_CURSOR));
    }
    public void stopWait() {
        setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
    }
}
